/*
 * Timed message - HeXHub sample plugin code
 * Written by Morten Larsen, bluebear dot dk at gmail dot com
 * (C) Copyright 2007  Morten Larsen
 * License: Free without any restrictions other that you cant sue me
 */

#define  _WIN32_WINNT 0x0500

#include <windows.h>
#include <sstream>
#include "HeXHuB.h"

HANDLE hTimerQ = 0;
HANDLE hTimer = 0;

// Change this line if you want to change the interval in milisecs
unsigned int iTimerPeriod = 7200000; // 120 mins (min*secs*ms (120*60*1000))

// Change this line if you want to change the amout of time before its send first time after the plugin is loaded
unsigned int iDueTime = 120000; // 2 mins

VOID CALLBACK OnTimer(PVOID lpParam, BOOL TimerOrWaitFired) {
	std::stringstream os;
	DWORD bytes;
	char hubbot[MAX_NICK];
	char buf[4096];
	HANDLE hFile;

	if (HexHubFunctions::ClientNickFromId(HUBBOT_ID, hubbot) == false) return;

	hFile = CreateFile(L".\\Plugins\\TimedMessage.txt", GENERIC_READ, 0, 0, OPEN_EXISTING, 0, 0);
	if (hFile == INVALID_HANDLE_VALUE) {
		return;
	}

	if (GetFileSize(hFile, 0) == 0) {
		CloseHandle(hFile);
		return;
	}

	os << "<" << hubbot << "> ";

	while (ReadFile(hFile, buf, 4095, &bytes, 0) == TRUE) {
		if (bytes == 0) break;
		buf[bytes] = 0;
		os << buf;
	}
	CloseHandle(hFile);

	os << "|";
	HexHubFunctions::SendToAll(os.str().c_str(), static_cast<int>(os.str().length()));
}


const char * HEXHUBAPI InitPlugin(lpfnGetFunction HexGetFunction) {
	HexHubFunctions hhf;
	if (hhf.Init(HexGetFunction) == false) return 0;

	hTimerQ = CreateTimerQueue();
	if (hTimerQ == 0) return 0;
	if (CreateTimerQueueTimer(&hTimer, hTimerQ, (WAITORTIMERCALLBACK)OnTimer, 0, iDueTime, iTimerPeriod, 0) == 0) {
		DeleteTimerQueueEx(hTimerQ, INVALID_HANDLE_VALUE);
		return 0;
	}

	return "Timed message 0.1 by bluebear";
}

void HEXHUBAPI UnloadPlugin(void) {
	if (hTimerQ != 0) DeleteTimerQueueEx(hTimerQ, INVALID_HANDLE_VALUE);
}
